package com.helix.tasks.model.impl;

import com.helix.tasks.model.Events;
import com.helix.tasks.model.EventsModel;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;
import com.liferay.portal.util.PortalUtil;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the Events service. Represents a row in the &quot;Helix_Events&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link com.helix.tasks.model.EventsModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link EventsImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see EventsImpl
 * @see com.helix.tasks.model.Events
 * @see com.helix.tasks.model.EventsModel
 * @generated
 */
public class EventsModelImpl extends BaseModelImpl<Events>
    implements EventsModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a events model instance should use the {@link com.helix.tasks.model.Events} interface instead.
     */
    public static final String TABLE_NAME = "Helix_Events";
    public static final Object[][] TABLE_COLUMNS = {
            { "eventId", Types.BIGINT },
            { "sourceId", Types.BIGINT },
            { "groupId", Types.BIGINT },
            { "companyId", Types.BIGINT },
            { "userId", Types.BIGINT },
            { "createDate", Types.TIMESTAMP },
            { "modifiedDate", Types.TIMESTAMP },
            { "url", Types.VARCHAR },
            { "name", Types.VARCHAR },
            { "time_", Types.VARCHAR },
            { "location", Types.VARCHAR },
            { "imageEu", Types.VARCHAR },
            { "relativeLinkToSite", Types.VARCHAR },
            { "siteUuid", Types.VARCHAR }
        };
    public static final String TABLE_SQL_CREATE = "create table Helix_Events (eventId LONG not null primary key,sourceId LONG,groupId LONG,companyId LONG,userId LONG,createDate DATE null,modifiedDate DATE null,url TEXT null,name TEXT null,time_ VARCHAR(75) null,location TEXT null,imageEu VARCHAR(75) null,relativeLinkToSite TEXT null,siteUuid VARCHAR(75) null)";
    public static final String TABLE_SQL_DROP = "drop table Helix_Events";
    public static final String ORDER_BY_JPQL = " ORDER BY events.eventId ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Helix_Events.eventId ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.com.helix.tasks.model.Events"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.com.helix.tasks.model.Events"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.com.helix.tasks.model.Events"),
            true);
    public static long SOURCEID_COLUMN_BITMASK = 1L;
    public static long EVENTID_COLUMN_BITMASK = 2L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.com.helix.tasks.model.Events"));
    private static ClassLoader _classLoader = Events.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] { Events.class };
    private long _eventId;
    private long _sourceId;
    private long _originalSourceId;
    private boolean _setOriginalSourceId;
    private long _groupId;
    private long _companyId;
    private long _userId;
    private String _userUuid;
    private Date _createDate;
    private Date _modifiedDate;
    private String _url;
    private String _name;
    private String _time;
    private String _location;
    private String _imageEu;
    private String _relativeLinkToSite;
    private String _siteUuid;
    private long _columnBitmask;
    private Events _escapedModel;

    public EventsModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _eventId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setEventId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _eventId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return Events.class;
    }

    @Override
    public String getModelClassName() {
        return Events.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("eventId", getEventId());
        attributes.put("sourceId", getSourceId());
        attributes.put("groupId", getGroupId());
        attributes.put("companyId", getCompanyId());
        attributes.put("userId", getUserId());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("url", getUrl());
        attributes.put("name", getName());
        attributes.put("time", getTime());
        attributes.put("location", getLocation());
        attributes.put("imageEu", getImageEu());
        attributes.put("relativeLinkToSite", getRelativeLinkToSite());
        attributes.put("siteUuid", getSiteUuid());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long eventId = (Long) attributes.get("eventId");

        if (eventId != null) {
            setEventId(eventId);
        }

        Long sourceId = (Long) attributes.get("sourceId");

        if (sourceId != null) {
            setSourceId(sourceId);
        }

        Long groupId = (Long) attributes.get("groupId");

        if (groupId != null) {
            setGroupId(groupId);
        }

        Long companyId = (Long) attributes.get("companyId");

        if (companyId != null) {
            setCompanyId(companyId);
        }

        Long userId = (Long) attributes.get("userId");

        if (userId != null) {
            setUserId(userId);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        String url = (String) attributes.get("url");

        if (url != null) {
            setUrl(url);
        }

        String name = (String) attributes.get("name");

        if (name != null) {
            setName(name);
        }

        String time = (String) attributes.get("time");

        if (time != null) {
            setTime(time);
        }

        String location = (String) attributes.get("location");

        if (location != null) {
            setLocation(location);
        }

        String imageEu = (String) attributes.get("imageEu");

        if (imageEu != null) {
            setImageEu(imageEu);
        }

        String relativeLinkToSite = (String) attributes.get(
                "relativeLinkToSite");

        if (relativeLinkToSite != null) {
            setRelativeLinkToSite(relativeLinkToSite);
        }

        String siteUuid = (String) attributes.get("siteUuid");

        if (siteUuid != null) {
            setSiteUuid(siteUuid);
        }
    }

    @Override
    public long getEventId() {
        return _eventId;
    }

    @Override
    public void setEventId(long eventId) {
        _eventId = eventId;
    }

    @Override
    public long getSourceId() {
        return _sourceId;
    }

    @Override
    public void setSourceId(long sourceId) {
        _columnBitmask |= SOURCEID_COLUMN_BITMASK;

        if (!_setOriginalSourceId) {
            _setOriginalSourceId = true;

            _originalSourceId = _sourceId;
        }

        _sourceId = sourceId;
    }

    public long getOriginalSourceId() {
        return _originalSourceId;
    }

    @Override
    public long getGroupId() {
        return _groupId;
    }

    @Override
    public void setGroupId(long groupId) {
        _groupId = groupId;
    }

    @Override
    public long getCompanyId() {
        return _companyId;
    }

    @Override
    public void setCompanyId(long companyId) {
        _companyId = companyId;
    }

    @Override
    public long getUserId() {
        return _userId;
    }

    @Override
    public void setUserId(long userId) {
        _userId = userId;
    }

    @Override
    public String getUserUuid() throws SystemException {
        return PortalUtil.getUserValue(getUserId(), "uuid", _userUuid);
    }

    @Override
    public void setUserUuid(String userUuid) {
        _userUuid = userUuid;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public String getUrl() {
        if (_url == null) {
            return StringPool.BLANK;
        } else {
            return _url;
        }
    }

    @Override
    public void setUrl(String url) {
        _url = url;
    }

    @Override
    public String getName() {
        if (_name == null) {
            return StringPool.BLANK;
        } else {
            return _name;
        }
    }

    @Override
    public void setName(String name) {
        _name = name;
    }

    @Override
    public String getTime() {
        if (_time == null) {
            return StringPool.BLANK;
        } else {
            return _time;
        }
    }

    @Override
    public void setTime(String time) {
        _time = time;
    }

    @Override
    public String getLocation() {
        if (_location == null) {
            return StringPool.BLANK;
        } else {
            return _location;
        }
    }

    @Override
    public void setLocation(String location) {
        _location = location;
    }

    @Override
    public String getImageEu() {
        if (_imageEu == null) {
            return StringPool.BLANK;
        } else {
            return _imageEu;
        }
    }

    @Override
    public void setImageEu(String imageEu) {
        _imageEu = imageEu;
    }

    @Override
    public String getRelativeLinkToSite() {
        if (_relativeLinkToSite == null) {
            return StringPool.BLANK;
        } else {
            return _relativeLinkToSite;
        }
    }

    @Override
    public void setRelativeLinkToSite(String relativeLinkToSite) {
        _relativeLinkToSite = relativeLinkToSite;
    }

    @Override
    public String getSiteUuid() {
        if (_siteUuid == null) {
            return StringPool.BLANK;
        } else {
            return _siteUuid;
        }
    }

    @Override
    public void setSiteUuid(String siteUuid) {
        _siteUuid = siteUuid;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(getCompanyId(),
            Events.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public Events toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (Events) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        EventsImpl eventsImpl = new EventsImpl();

        eventsImpl.setEventId(getEventId());
        eventsImpl.setSourceId(getSourceId());
        eventsImpl.setGroupId(getGroupId());
        eventsImpl.setCompanyId(getCompanyId());
        eventsImpl.setUserId(getUserId());
        eventsImpl.setCreateDate(getCreateDate());
        eventsImpl.setModifiedDate(getModifiedDate());
        eventsImpl.setUrl(getUrl());
        eventsImpl.setName(getName());
        eventsImpl.setTime(getTime());
        eventsImpl.setLocation(getLocation());
        eventsImpl.setImageEu(getImageEu());
        eventsImpl.setRelativeLinkToSite(getRelativeLinkToSite());
        eventsImpl.setSiteUuid(getSiteUuid());

        eventsImpl.resetOriginalValues();

        return eventsImpl;
    }

    @Override
    public int compareTo(Events events) {
        long primaryKey = events.getPrimaryKey();

        if (getPrimaryKey() < primaryKey) {
            return -1;
        } else if (getPrimaryKey() > primaryKey) {
            return 1;
        } else {
            return 0;
        }
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof Events)) {
            return false;
        }

        Events events = (Events) obj;

        long primaryKey = events.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        EventsModelImpl eventsModelImpl = this;

        eventsModelImpl._originalSourceId = eventsModelImpl._sourceId;

        eventsModelImpl._setOriginalSourceId = false;

        eventsModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<Events> toCacheModel() {
        EventsCacheModel eventsCacheModel = new EventsCacheModel();

        eventsCacheModel.eventId = getEventId();

        eventsCacheModel.sourceId = getSourceId();

        eventsCacheModel.groupId = getGroupId();

        eventsCacheModel.companyId = getCompanyId();

        eventsCacheModel.userId = getUserId();

        Date createDate = getCreateDate();

        if (createDate != null) {
            eventsCacheModel.createDate = createDate.getTime();
        } else {
            eventsCacheModel.createDate = Long.MIN_VALUE;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            eventsCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            eventsCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        eventsCacheModel.url = getUrl();

        String url = eventsCacheModel.url;

        if ((url != null) && (url.length() == 0)) {
            eventsCacheModel.url = null;
        }

        eventsCacheModel.name = getName();

        String name = eventsCacheModel.name;

        if ((name != null) && (name.length() == 0)) {
            eventsCacheModel.name = null;
        }

        eventsCacheModel.time = getTime();

        String time = eventsCacheModel.time;

        if ((time != null) && (time.length() == 0)) {
            eventsCacheModel.time = null;
        }

        eventsCacheModel.location = getLocation();

        String location = eventsCacheModel.location;

        if ((location != null) && (location.length() == 0)) {
            eventsCacheModel.location = null;
        }

        eventsCacheModel.imageEu = getImageEu();

        String imageEu = eventsCacheModel.imageEu;

        if ((imageEu != null) && (imageEu.length() == 0)) {
            eventsCacheModel.imageEu = null;
        }

        eventsCacheModel.relativeLinkToSite = getRelativeLinkToSite();

        String relativeLinkToSite = eventsCacheModel.relativeLinkToSite;

        if ((relativeLinkToSite != null) && (relativeLinkToSite.length() == 0)) {
            eventsCacheModel.relativeLinkToSite = null;
        }

        eventsCacheModel.siteUuid = getSiteUuid();

        String siteUuid = eventsCacheModel.siteUuid;

        if ((siteUuid != null) && (siteUuid.length() == 0)) {
            eventsCacheModel.siteUuid = null;
        }

        return eventsCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(29);

        sb.append("{eventId=");
        sb.append(getEventId());
        sb.append(", sourceId=");
        sb.append(getSourceId());
        sb.append(", groupId=");
        sb.append(getGroupId());
        sb.append(", companyId=");
        sb.append(getCompanyId());
        sb.append(", userId=");
        sb.append(getUserId());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", url=");
        sb.append(getUrl());
        sb.append(", name=");
        sb.append(getName());
        sb.append(", time=");
        sb.append(getTime());
        sb.append(", location=");
        sb.append(getLocation());
        sb.append(", imageEu=");
        sb.append(getImageEu());
        sb.append(", relativeLinkToSite=");
        sb.append(getRelativeLinkToSite());
        sb.append(", siteUuid=");
        sb.append(getSiteUuid());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(46);

        sb.append("<model><model-name>");
        sb.append("com.helix.tasks.model.Events");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>eventId</column-name><column-value><![CDATA[");
        sb.append(getEventId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>sourceId</column-name><column-value><![CDATA[");
        sb.append(getSourceId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>groupId</column-name><column-value><![CDATA[");
        sb.append(getGroupId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>companyId</column-name><column-value><![CDATA[");
        sb.append(getCompanyId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>userId</column-name><column-value><![CDATA[");
        sb.append(getUserId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>url</column-name><column-value><![CDATA[");
        sb.append(getUrl());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>name</column-name><column-value><![CDATA[");
        sb.append(getName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>time</column-name><column-value><![CDATA[");
        sb.append(getTime());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>location</column-name><column-value><![CDATA[");
        sb.append(getLocation());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>imageEu</column-name><column-value><![CDATA[");
        sb.append(getImageEu());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>relativeLinkToSite</column-name><column-value><![CDATA[");
        sb.append(getRelativeLinkToSite());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>siteUuid</column-name><column-value><![CDATA[");
        sb.append(getSiteUuid());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
